#ifndef __VITAS_ERR_H_
#define __VITAS_ERR_H_

#include<stdio.h>

#ifdef __cplusplus


extern "C" {
#endif

void err(char *fmt, ...);
void db(char *fmt, ...);
void war(char *fmt, ...);

void errl(char *func_name, int lineno, char *fmt, ...);
void warl(char *func_name, int lineno, char *fmt, ...);

#ifdef __cplusplus
}
#endif

#ifdef __cplusplus
#include <string>
#include <stdarg.h>

using namespace std;

/* pokud preprocesor nepodporuje  ... staci muze se pouzit prvni
 * definice (bude hlasit bez mista ve zdrojaku...
 */
#if 0
#if 1
#define EX t_ex
#else
#define EX(ex_id, fmt,ar...) t_ex(ex_id, __FILE__,__LINE__,__PRETTY_FUNCTION__,fmt, ar)
#endif

enum ex_e{
	ex_range, /* int ve spatnem rozmezi */
	ex_twicedecl,  /* trysky, svetla a podobne ...
			* jsou deklarovane podruhe 
			*/
	ex_stck_under, /* zasobnik podtekl */
	ex_stck_bad_type, /* na zasobniku bylo jineho nez se ocekavalo */
	ex_defs_bad, /* nejaky neporadek v poli defsmap */
	ex_id_not_valid, /* identifiakor fce neni ve tvaru
                          * nameN kde N je 0..9 */
	ex_exe_bad,	/*neco spatneho pri exe */
	ex_no_such_prim, /* takovy primitiv neexistuje */
	ex_no_such_param, /* takovy parametr neexistuje */
	ex_no_such_id, /* takovy parametr neexistuje */
	ex_no_such_com, /* takovy prikaz neexistuje */
	ex_unexcepted_com,  /* neocekavany prikaz */
	ex_last_exception

};

#endif
#define ERR 

class t_ex
{
public:
        string s;
#if 0
        t_ex(char*file="stdin", int line=-1, char *pfunc="", char *fmt ="",...){
                char buff[1024];
                va_list ap;
                va_start(ap, fmt);
                vsnprintf(buff, 180, fmt, ap);
                s = string(filebuff2) + string(buff);
                va_end(ap);
        }
#endif
#define EX_BUF_SIZ 200
        t_ex(char *fmt = "",...){
                char buff[EX_BUF_SIZ];
                va_list ap;
                va_start(ap, fmt);
                vsnprintf(buff, EX_BUF_SIZ, fmt, ap);
                s = string(buff) + '\n';
                va_end(ap);
        };
	t_ex&
	add(char *fmt = "", ... )
	{
                char buff[EX_BUF_SIZ];
                va_list ap;
                va_start(ap, fmt);
                vsnprintf(buff, EX_BUF_SIZ, fmt, ap);
                s += string(buff) + '\n';
                va_end(ap);
		return *this;
	};
}; /* class ex */

inline ostream&
operator<<(ostream &o, t_ex &e) {
	o << e.s;
	return o;
} /* operator<< */

#endif /* __cplusplus */
#endif
